@page "/cart"
@using Shop.StoreFront.Models
@using Newtonsoft.Json
@using Shop.StoreFront.Requests

@inject HttpClient HttpClient;

@if (_order != null)
{
    <div class="card">
        <div class="card-header">
            Shopping cart
        </div>
        <div class="card-body">
            <table class="table">
                <thead class="thead-dark">
                <tr>
                    <td>Product Title</td>
                    <td>Quantity</td>
                    <td>Price</td>
                </tr>
                </thead>
                <tbody>
                @foreach (var item in _order.OrderItems)
                {
                    <tr>
                        <td>@item.Product.Title</td>
                        <td>
                            <ul class="pagination">
                                <li class="page-item @(item.Quantity == 1 ? "disabled" : "")"><span class="page-link" @onclick="() => DecreaseQuantityAsync(item)">-</span></li>
                                <li class="page-item disabled"><a class="page-link disabled" href="#">@item.Quantity</a></li>
                                <li class="page-item"><span class="page-link" @onclick="() => IncreaseQuantityAsync(item)">+</span></li>
                            </ul>
                        </td>
                        <td>@item.TotalPrice</td>
                    </tr>
                }
                </tbody>
            </table>
            <table class="table">
                <thead class="thead-dark">
                <tr>
                    <td>Discount Code</td>
                    <td>Type</td>
                    <td>Amount</td>
                </tr>
                </thead>
                <tbody>
                @foreach (var item in _order.OrderDiscounts)
                {
                    <tr>
                        <td>@item.Discount.Code</td>
                        <td>@item.Discount.Type</td>
                        <td>-@item.Discount.Amount</td>
                    </tr>
                }
                </tbody>
            </table>
        </div>
        <div class="card-footer">
            <div class="row">
                <div class="col-md-3">
                    <EditForm class="form-inline my-1 my-lg-0" Model="@_applyDiscountRequest" OnValidSubmit="ApplyDiscountCodeAsync">
                        <DataAnnotationsSummary />
                        <ValidationSummary />
                        
                        <InputText class="form-control mr-sm-2" type="search" placeholder="Dsicount code" aria-label="Dsicount code" @bind-Value="_applyDiscountRequest.Code"/>
                        <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Apply</button>
                    </EditForm>
                </div>
                <div class="col-md-1 offset-md-7">
                    <p>Total: @_order.TotalPrice</p>
                </div>
                <div class="col-md-1">
                    <form class="form-inline my-2 my-lg-0">
                        <button class="btn btn-primary my-2 my-sm-0" type="submit">Checkout</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
}


@code
{
    private Order _order;
    private ApplyDiscountRequest _applyDiscountRequest = new ApplyDiscountRequest();
    
    protected override async Task OnInitializedAsync()
    {
        var response = await HttpClient
            .GetAsync($"https://localhost:5001/api/Order/CurrentCart");

        if (response.IsSuccessStatusCode)
        {
            var json = await response.Content.ReadAsStringAsync();
            _order = JsonConvert.DeserializeObject<Order>(json);
        }
    }

    public async Task IncreaseQuantityAsync(OrderItem item)
    {
        var url = $"https://localhost:5001/api/Order/AddProductToOrder/{item.Product.Id}";
        var response = await HttpClient.PostAsync(url, null);
        if (response.IsSuccessStatusCode)
        {
            item.Quantity++;
            item.RecalculatePrice();
            _order.CalculateTotalPrice();
        }
    }
    
    public async Task DecreaseQuantityAsync(OrderItem item)
    {
        if (item.Quantity == 1)
        {
            return;
        }
        
        var url = $"https://localhost:5001/api/Order/ReduceProductQuantity/{item.Product.Id}";
        var response = await HttpClient.PutAsync(url, null);
        if (response.IsSuccessStatusCode)
        {
            item.Quantity--;
            item.RecalculatePrice();
            _order.CalculateTotalPrice();
        }
    }

    public async Task ApplyDiscountCodeAsync()
    {
        var url = $"https://localhost:5001/api/Order/ApplyDiscountToOrder/{_applyDiscountRequest.Code}";
        var response = await HttpClient.PutAsync(url, null);

        if (response.IsSuccessStatusCode)
        {
            var content = await response.Content.ReadAsStringAsync();
            _order = JsonConvert.DeserializeObject<Order>(content);
        }
    }
}
